#include <stdio.h>

int main( void )
{ 
   int loop;   /* loop counter */
   int number; /* current number */
   int temp1;  /* temporary integer */

   FILE *output_file = 0 ;

   /* open output file */
   if ( ( output_file = fopen( "3_1out.dat", "w" ) ) == NULL ) {
      printf( "Output file was not opened.\n" );
   } /* end if */

   /* print table headers */
   fprintf(output_file, "Decimal\t\tBinary\t\tOctal\t\tHexadecimal\n" );

   /* loop through values 1 to 256 */
   for ( loop = 1; loop <= 256; loop++ ) { 
      fprintf(output_file, "%d\t\t", loop );
      number = loop;

      /* binary numbers */
      fprintf(output_file, "%c", number == 256 ? '1' : '0' );

      fprintf(output_file, "%c", number < 256 && number >= 128 ? '1' : '0' );
      number %= 128;

      fprintf(output_file, "%c", number < 128 && number >= 64 ? '1' : '0' );
      number %= 64;

      fprintf(output_file, "%c", number < 64 && number >= 32 ? '1' : '0' );
      number %= 32;

      fprintf(output_file, "%c", number < 32 && number >= 16 ? '1' : '0' );
      number %= 16;

      fprintf(output_file, "%c", number < 16 && number >= 8 ? '1' : '0' );
      number %= 8;

      fprintf(output_file, "%c", number < 8 && number >= 4 ? '1' : '0' );
      number %= 4;

      fprintf(output_file, "%c", number < 4 && number >= 2 ? '1' : '0' );
      number %= 2;

      fprintf(output_file, "%c\t", number == 1 ? '1' : '0' );

      /* octal numbers */
      number = loop;

      fprintf(output_file, "%d", number < 512 && number >= 64 ? number / 64 : 0 );
      number %= 64;

      fprintf(output_file, "%d", number < 64 && number >= 8 ? number / 8 : 0 );
      number %= 8;

      fprintf(output_file, "%d\t\t", number == 0 ? 0 : number );

      /* hexadecimal numbers */
      number = loop;
      temp1 = 16;

      if ( number < 4096 && number >= 256 ) {
         fprintf(output_file, "%d", number / 256 );
      } /* end if */

      if ( number < 256 && number >= 16 ) { 
         temp1 = number / 16;
         number %= 16;
      } /* end if */
      else {
         fprintf(output_file, "0" );
      } /* end else */

      /* convert to letter if temp1 is above 9 */
      if ( temp1 <= 9 ) {
         fprintf(output_file, "%d", temp1 );
      } /* end if */
      else if ( temp1 >= 10 && temp1 <= 15 ) {
         fprintf(output_file, "%c", 'A' + ( temp1 - 10 ) );
      } /* end else if */

      /* convert to letter if number is above 9 */
      if ( number <= 9 ) {
         fprintf(output_file, "%d", number );
      } /* end if */
      else if ( number >= 10 && number <= 15 ) {
         fprintf(output_file, "%c", 'A' + ( number - 10 ) );
      } /* end else if */

      fprintf(output_file, "\n" );
   } /* end for */

   fclose(output_file);
   
   return 0; /* indicate successful termination */

} /* end main */
